#include <iostream>
#include <cmath>

using namespace std;

int main() {
	int w, h, r, q;
	cin>>w>>h>>r>>q;
	
	double visine[w+1];
	for(int i=0; i<w+1; i++){
		visine[i] = h;
	}
	
	for(int i=0; i<q; i++){
		int id;
		cin>>id;
		if(id==1){
			double xi, yi;
			cin>>xi>>yi;
			
			for(int j=0; j<w+1; j++){
				if(j>=xi-r && j<=xi+r){
					double top=yi-sqrt(r*r-(xi-j)*(xi-j));
					if(top<visine[j]){
						visine[j]=top;
					}
				}
			}
		}
		else{
			int xi;
			cin>>xi;
			printf("%.8f", visine[xi]);
		}
	}
	
	return 0;
}